/* Should this solution pass TL? */

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <set>
#include <vector>
#include <map>
#include <cmath>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cassert>

using namespace std;

const int MAX = 177513;      
const int mod = (int) 1e9 + 7;

struct MyHashMap {           
	int vals[MAX];
	int vals2[MAX];
    int used[MAX];
    int usedSz;

    MyHashMap() {
        for (int i = 0; i < MAX; i++) 
        	vals[i] = -1;
        usedSz = 0;
    }

    void clear() {
        for (int i = 0; i < usedSz; i++) {
            vals[used[i]] = -1;
        }
        usedSz = 0;
    }

    void put(int x, int value) {
        int hash = x % MAX;
        while (vals[hash] != x && vals[hash] != -1) {
            hash++;
            if (hash == MAX)
                hash = 0;
        }
        if (vals[hash] == -1) {
            vals[hash] = x;
            vals2[hash] = 0;
            used[usedSz++] = hash;
        }
        vals2[hash] += value;
        if (vals2[hash] >= mod)
            vals2[hash] -= mod;
    }
};
                              
string can = "BWG";

int main() {
	int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (int i = 0; i < n; i++) 
    	cin >> s[i];
    int start = (1 << (2 * n)) - 1;
    MyHashMap * hm = new MyHashMap();
    MyHashMap * hm2 = new MyHashMap();
    hm->put(start, 1);
    vector<int> masks;
    for (int j = 0; j < 15; j++) {
    	int need = -1;
    	need ^= 1 << (j * 2);
    	need ^= 1 << (j * 2 + 1);
    	masks.push_back(need);
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {             
            for (int kk = 0; kk < hm->usedSz; kk++) {
                int curVal = hm->vals[hm->used[kk]];
                int curCnt = hm->vals2[hm->used[kk]];
                for (int cc = 0; cc < 3; cc++) {
                	char c = can[cc];
                    if (c == s[j][i] || s[j][i] == '.') {
                    	if (cc != ((curVal >> (j * 2)) & 3))
                        	if (j == 0 || cc != ((curVal >> (j * 2 - 2)) & 3)) {
                            	int newString = curVal & masks[j];
                                newString |= cc << (j * 2);
                                hm2->put(newString, curCnt);
                        	}
                    }
                }
            }
            MyHashMap * tmp = hm;
            hm = hm2;
            hm2 = tmp;
            hm2->clear();
        }
    }
    long long res = 0;
    for (int i = 0; i < hm->usedSz; i++) {
        res += hm->vals2[hm->used[i]];
    }
    cout << res % mod << endl;
}
