import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import ru.ifmo.testlib.Outcome.Type;


public class Check implements Checker {
    
    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        long partAns = ouf.nextLong(), juryAns = ans.nextLong();
        if (partAns != juryAns) {
            return new Outcome(Type.WA, "Expected: " + juryAns + ", found: " + partAns);
        }
        return new Outcome(Type.OK, "OK");
    }
}
