import java.io.*;
import java.util.*;

public class chess_vd_veryslow {
	
	int[][] field;
	int[][] a;

	int n,m,cnt = 0;
	
	void gen(int i, int j) {
		boolean[] free = new boolean[3];
		if (j == m) {
			gen(i + 1, 0);
			return;
		}
		if (i == n) {
			cnt++;
			return;
		}
		if (field[i][j] != -1) {
			Arrays.fill(free, true);
			free[field[i][j]] = false;
		}
		if (i > 0) {
			free[a[i - 1][j]] = true;
		}
		if (j > 0) {
			free[a[i][j - 1]] = true;
		}

		
		for (int val = 0; val < 3; val++) {
			if (!free[val]) {
				a[i][j] = val;
				gen(i, j + 1);
			}
		}

	}

	
	public void solve() throws IOException {
		n = nextInt();
		m = nextInt();
		field = new int[n][m];
		for (int i = 0; i < n; i++) {
			String s = next();
			for (int j = 0; j < s.length(); j++) {
				if (s.charAt(j) == '.') {
					field[i][j] = -1;
				} else if (s.charAt(j) == 'B') {
					field[i][j] = 0;
				} else if (s.charAt(j) == 'W') {
					field[i][j] = 1;
				} else {
					field[i][j] = 2;
				}
			}
		}
		a = new int[n][m];
		gen(0, 0);
		out.println(cnt);
	}

	final String fileName = "chess_vd_".split("_")[0];

	public void run() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
		br.close();
	}

	public static void main(String[] args) throws IOException {
		new chess_vd_veryslow().run();
	}

	BufferedReader br;
	StringTokenizer str;
	PrintWriter out;

	String next() throws IOException {
		while (str == null || !str.hasMoreTokens()) {
			str = new StringTokenizer(br.readLine());
		}
		return str.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

}