import java.io.*;
import java.util.*;

public class timer_av {

	public void solve() {
		int x = in.nextInt(), y = in.nextInt(), k = in.nextInt(), t = in.nextInt();
		out.println(go(x, y, k, t));
	}

	long go(long x, long y, long k, long t) {
		if (k == 0) {
			return x + t;
		}
		if (t == 0) {
			return (x + y - 1) / y;
		}
		
		if (x % y == 0) {
			return x + goFrom0(y, k, t);
		}
		
		long res = goFrom0(y, k - 1, t);
		if (x % y > 0) {
			long need = y - x % y;
			if (t >= need) {
				res = Math.max(res, goFrom0(y, k, t - need));
			}
		}
		return (x + y - 1) / y * y + res;
	}
	
	long goFrom0(long y, long k, long t) {
		k = Math.min(k, t);
		return t + (y - 1) * k;
	}

	FastScanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new FastScanner();
			out = new PrintWriter(System.out);
			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}


	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String name) {
			try {
				br = new BufferedReader(new FileReader(name));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new timer_av().run();
	}
}
