import java.io.*;
import java.util.*;

public class timer_av_dp_tl {

	public void solve() {
		int x = in.nextInt(), y = in.nextInt(), k = in.nextInt(), t = in.nextInt();
		out.println(stupid(x, y, k, t));
	}
	
	long stupid(int x, int y, int k, int t) {
		long[][] dp = new long[t + 1][k + 1];
		dp[0][0] = x;
		
		for (int i = 0; i <= t; i++) {
			for (int j = 0; j <= k; j++) {
				if (i + 1 <= t) {
					dp[i + 1][j] = Math.max(dp[i + 1][j], dp[i][j] + 1);
				}
				if (j + 1 <= k) {
					dp[i][j + 1] = Math.max(dp[i][j + 1], (dp[i][j] + y - 1) / y * y);
				}
			}
		}
		
		long max = 0;
		for (int i = 0; i <= k; i++) {
			max = Math.max(max, dp[t][i]);
		}
		return max;
	}

	FastScanner in;
	PrintWriter out;

	public void run() {
		try {
			in = new FastScanner();
			out = new PrintWriter(System.out);
			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String name) {
			try {
				br = new BufferedReader(new FileReader(name));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new timer_av_dp_tl().run();
	}
}
