import java.io.*;
import java.util.*;

public class timer_bm {
    FastScanner in;
    PrintWriter out;

    void solve() {
        int tt = in.nextInt();
        for (int t = 0; t < tt; t++) {
            long start = in.nextLong();
            long divBy = in.nextLong();
            long canUse = in.nextLong();
            long time = in.nextLong();
            long res = 0;
            {
                long start2 = (1 + (start - 1) / divBy) * divBy;
                start2 += Math.min(canUse - 1, time) * divBy;
                start2 += Math.max(0, time - canUse + 1);
                res = Math.max(res, start2);
            }
            {
                long start2 = (1 + (start - 1) / divBy) * divBy;
                time -= start2 - start;
                if (time >= 0) {
                    start2 += Math.min(canUse, time) * divBy;
                    start2 += Math.max(0, time - canUse);
                    res = Math.max(res, start2);   
                }
            }
            out.println(res);
        }
    }

    void run() {
        try {
            in = new FastScanner(new File("object.in"));
            out = new PrintWriter(new File("object.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] args) {
        new timer_bm().runIO();
    }
}